Attribute VB_Name = "MiscProcs"
'----------------------------------------------------------------------
' MiscProcs - Murphy McCauley 08/12/99
'----------------------------------------------------------------------
' These are just a couple of functions I took out of MurfLib 4 and
' stripped down.
' ForceForegroundWindow() pushes a window to the front -- even in
' Win98/NT4+ (which generally prohibit this behavior).
'----------------------------------------------------------------------
' o|~ Men are from Mars, men are from Mars, men are from Mars...
'----------------------------------------------------------------------

Option Explicit

'Stuff for ForceForegroundWindow()...
Private Const SPI_GETFOREGROUNDLOCKTIMEOUT = &H2000&
Private Const SPI_SETFOREGROUNDLOCKTIMEOUT = &H2001&
Private Declare Function SystemParametersInfo Lib "user32" Alias "SystemParametersInfoA" (ByVal uAction As Long, ByVal uParam As Long, ByRef lpvParam As Any, ByVal fuWinIni As Long) As Long
Private Declare Function SetForegroundWindow Lib "user32" (ByVal hwnd As Long) As Long
Private Declare Function GetForegroundWindow Lib "user32" () As Long

'Stuff for the mouse functions...
Type APoint
    x As Long
    y As Long
End Type
'Declare Function GetCursorPos Lib "user32" (Point As APoint) As Long
Declare Function SetCursorPos Lib "user32" (ByVal x As Long, ByVal y As Long) As Long
Declare Function GetAsyncKeyState Lib "user32" (ByVal VirtualKey As Long) As Long


Function ForceForegroundWindow(TheHWnd As Long)
    If TheHWnd <> GetForegroundWindow Then
        Dim OriginalTimeout As Long
        Dim TempL As Long, uP As Long
        Dim Success As Long
        Success = SystemParametersInfo(SPI_GETFOREGROUNDLOCKTIMEOUT, uP, OriginalTimeout, 0)
        If Success <> 0 Then
            Call SystemParametersInfo(SPI_SETFOREGROUNDLOCKTIMEOUT, uP, ByVal 0, 0)
        End If
        
        Call SetForegroundWindow(TheHWnd)
        If Success <> 0 Then
            Call SystemParametersInfo(SPI_SETFOREGROUNDLOCKTIMEOUT, uP, ByVal OriginalTimeout, 0)
        End If
    End If
End Function

Function MousePointerPosition() As APoint
    'Not exactly what's in MurfLib4... I stripped it down.
    Dim CurrentPos As APoint
    'Call GetCursorPos(CurrentPos)
    MousePointerPosition = CurrentPos
End Function

Function MouseButtonIsDown() As Boolean
    'Not exactly what's in MurfLib4... I stripped it down.
    
    Dim IsDown As Boolean
            
    If (GetAsyncKeyState(1) = -32767) Or ((GetAsyncKeyState(1) And 2 ^ 15) <> 0) Then
        IsDown = True
    ElseIf (GetAsyncKeyState(2) = -32767) Or ((GetAsyncKeyState(2) And 2 ^ 15) <> 0) Then
        IsDown = True
    Else
        IsDown = False
    End If
    
    MouseButtonIsDown = IsDown
End Function

