Attribute VB_Name = "mPlayControl"
'Music Collector
'
'(c) 1999, 2000 by Joe Hart
'
'You do NOT have rights to redistribute this code, in whole or in part without
'my permission.  You also may not recompile the code and release
'it as another program without my permission.  If you would like to modify this code
'and distribute it in either as source code or as a compiled program please contact
'me at bghost@ti.cz before doing so.
'
'No warrantees either expressed or implied are granted with this software.
'Any damage arrising from use of this software is your own risk.
'
'mPlayControl.bas
'Accesses different MP3 Players, Including internal player using DirectX.
'And controls the playlist
Option Explicit
Public Scroll_Song  As String

Public Declare Function VkKeyScan Lib "user32" Alias "VkKeyScanA" (ByVal cChar As Byte) As Integer
Public Declare Function MapVirtualKey Lib "user32" Alias "MapVirtualKeyA" (ByVal wCode As Long, ByVal wMapType As Long) As Long

Public Sub ClearThePlaylist()
   'delete all items from the playlist
   
   'set flags
   fPlaylistChanged = True
   fCDUsed = False
   fPreviousWarning = False
   fSongChanged = True
   'depending on the player...
   Select Case gMusicPlayer
      Case InternalPlayer
         Set gMyPlaylist = New Collection
      Case WinAmpPlayer
         If WinAmpHwnd = 0 Then FindWinamp
         L = SendMessage(WinAmpHwnd, WM_WA_IPC, ZERO, IPC_DELETE)
      Case SoniquePlayer
         Shell (gsPlayerPath & " -clearplaylist")
   End Select
End Sub

Function AppendToPlayList(Filename As String) As Boolean
   'add a file to the playlist (of any player)
   
   'make sure the file is there, prompt for the CD if it is on CD
   'f = Data.VerifyFileExists(FileName)
   'If f = False Then Exit Function
    Filename = Left(Filename, Len(Filename) - 1)
   'depending on player
   Select Case gMusicPlayer
      Case InternalPlayer
         'Dim asPlayListItem(3) As String
         Dim asPlayListItem As String
         If gMyPlaylist Is Nothing Then
            Set gMyPlaylist = New Collection
         End If
         'prepare array
         'the filename
         asPlayListItem = Filename
         'asPlayListItem(0) = Filename
            'the title
         'asPlayListItem(1) = "" 'Data.Title
            'the artist
         'asPlayListItem(2) = "" 'Data.Artist
            'and the length
         'asPlayListItem(3) = "" 'Data.Duration
         'add the item
         gMyPlaylist.Add asPlayListItem
         fPlaylistChanged = True
    Case WinAmpPlayer
         AddFileToListNow Filename
    Case SoniquePlayer
         Shell (gsPlayerPath & " -appendonly " & sQuote2 & Filename & sQuote2)
   End Select
   
   'return true
   AppendToPlayList = True
End Function
Sub PlayCurrentSong()
   'play the current song
   Dim Result As VbMsgBoxResult
   
   
   gsCurFileName = Base.Song_To_Play
   
   
   
   If Base.Tracks_List.ListItems.count > 0 Then
   
        gsCurFileName = Base.Album_List.SelectedItem.SubItems(2) + "\" + Base.Tracks_List.SelectedItem.Text + Chr$(0)
   End If
   'exit if there is no current song
   If Len(gsCurFileName) = 0 Then Exit Sub
      
   'enable the timer
   'FMain.PlayerTimer.Enabled = True
   
   'check to see if player is already playing
   'if so, ask if they want to stop the player first
   Select Case gMusicPlayer
      Case InternalPlayer
         'If DXPlayerPlaying = True Then
            'Result = MsgBox(LS(148), vbYesNoCancel, LS(30))
            'Select Case Result
            'Case vbCancel 'don't play
            '   Exit Sub
            'Case vbNo 'play anyway
              'do nothing
            'Case vbYes 'enqueue the song
             '  AppendToPlayList gsCurFileName
             '  Exit Sub
            'End Select
         'End If
         gMyPlaylistPosition = 1
      Case WinAmpPlayer
         FindWinamp
         'check to see if winamp is alrady playing.
         If GetAmpState = asplay Then
            Result = MsgBox(LS(148), vbYesNoCancel, LS(30))
            Select Case Result
            Case vbCancel 'don't play
               Exit Sub
            Case vbYes 'enqueue
               AppendToPlayList gsCurFileName
               Exit Sub
            Case vbNo 'play anyway
               'do nothing here
            End Select
         End If
      Case SoniquePlayer
         'Can't check sonique, so don't do anything
   End Select
   
   'stop the player, clear the playlist, add the song to the playlist
   StopPlayer
   'ClearThePlaylist
   'AppendToPlayList gsCurFileName
   
   'and play it
   Scroll_Song = String(20, " ") + GetFileName(gsCurFileName)
   
   'Base.Update_Volume
   
   PlayNow
   
End Sub

Sub PlayPreviousSong()
   'play the previous song in the playlist
   
   'depending on player
   Select Case gMusicPlayer
      Case InternalPlayer
         'if there is no internal playlist, exit
         If gMyPlaylist Is Nothing Then Exit Sub
         'stop the player
         StopPlayer
         'decrement the playlist position
         gMyPlaylistPosition = gMyPlaylistPosition - 1
         'minimum playlist position number is 1
         If gMyPlaylistPosition < 1 Then gMyPlaylistPosition = 1
         'start playing
         DXPlayerStartPlay
      Case WinAmpPlayer
         If WinAmpHwnd = 0 Then FindWinamp
         L = SendMessage(WinAmpHwnd, WM_COMMAND, WINAMP_BUTTON1, ZERO)
      Case SoniquePlayer
         Shell (gsPlayerPath & " -seekprev")
   End Select
   'set the flag that the song changed
   fSongChanged = True
End Sub
Sub Rewind5Secs()
   'rewind 5 seconds
   
   'depending on player
   Select Case gMusicPlayer
      Case InternalPlayer
         'make sure the player is active
         If DXPlayer Is Nothing Then Exit Sub
         'get the song position
         i = DXPlayerPosition.CurrentPosition
         'decrement it by 5
         i = i - 5
         'minimum is 0
         If i < 0 Then i = 0
         'set the position
         DXPlayerPosition.CurrentPosition = i
      Case WinAmpPlayer
         If WinAmpHwnd = 0 Then FindWinamp
         L = SendMessage(WinAmpHwnd, WM_COMMAND, WINAMP_REW5S, ZERO)
      Case SoniquePlayer
         'Sonique can't do this
   End Select
End Sub
Sub FastForward5Secs()
   'fast forward 5 seconds
   
   'depending on player
   Select Case gMusicPlayer
      Case InternalPlayer
         'make sure the player is active
         If DXPlayer Is Nothing Then Exit Sub
         'get the song position
         i = DXPlayerPosition.CurrentPosition
         'increment it by 5
         i = i + 5
         'set the postion
         DXPlayerPosition.CurrentPosition = i
      Case WinAmpPlayer
         If WinAmpHwnd = 0 Then FindWinamp
         L = SendMessage(WinAmpHwnd, WM_COMMAND, WINAMP_FFWD5S, ZERO)
      Case SoniquePlayer
         'Sonique can't do this
   End Select
End Sub
Sub PausePlayer()
   'pause the player
   
   Static IsPaused As Boolean
   Dim MyState As Long
   Dim TheState As udtAmpState
   
   'depending on the player
   Select Case gMusicPlayer
   Case InternalPlayer
      'make sure the player is active
      If DXPlayer Is Nothing Then Exit Sub
      'get the state of the player
      DXPlayer.GetState L, MyState
      'and act on it
      If MyState = 2 Then
         IsPaused = True
         DXPlayer.Pause
      Else
         IsPaused = False
         DXPlayer.Run
      End If
   Case WinAmpPlayer
         If WinAmpHwnd = 0 Then FindWinamp
         L = SendMessage(WinAmpHwnd, WM_COMMAND, WINAMP_BUTTON3, ZERO)
         TheState = GetAmpState
         If TheState = asPause Then
            IsPaused = True
         Else
            IsPaused = False
         End If
   Case SoniquePlayer
      IsPaused = Not IsPaused
      If IsPaused Then
         Shell (gsPlayerPath & " -pause")
      Else
         Shell (gsPlayerPath & " -resume")
      End If
   End Select
End Sub
Sub StopPlayer()
   'stop the player
   
   'standard error handling
   On Error GoTo Hell
   'unload the lyrics form if there is one
   'If Not FLyrics Is Nothing Then
   '   Unload FLyrics
   '   Set FLyrics = Nothing
   'End If
   
   'depending on player
   Select Case gMusicPlayer
      Case InternalPlayer
         'make sure the player is active
         If DXPlayer Is Nothing Then Exit Sub
         'stop the player
         DXPlayer.Stop
      Case WinAmpPlayer
         If WinAmpHwnd = 0 Then FindWinamp
         L = SendMessage(WinAmpHwnd, WM_COMMAND, WINAMP_BUTTON4, ZERO)
      Case SoniquePlayer
         Shell (gsPlayerPath & " -stop")
   End Select
Hell:
   'clear song info and disable timer
   'FMain.CleanUp
   'set flags
   DXPlayerPlaying = False
   fSongChanged = True 'well, the state of the song changed.
   gsPlayingFileName = sEmpty
   'and set internal player to nothing
  ' ClearDXPlayer
End Sub
Sub ClearDXPlayer()
   'set internal player to nothing
   Set DXPlayer = Nothing
   Set DXPlayerPosition = Nothing
   Set DXPlayerAudio = Nothing
End Sub
Sub PlayNextSong()
   'play the next song in the playlist
   
   'depending on player
   Select Case gMusicPlayer
   Case InternalPlayer
       'make sure the player is active
      If DXPlayer Is Nothing Then Exit Sub
      'stop the player
      StopPlayer
      'increment playlist
      gMyPlaylistPosition = gMyPlaylistPosition + 1
      'max = number of songs in the playlist
      If gMyPlaylistPosition > gMyPlaylist.count Then
         If fPlayRepeat = True Then
            'start back at the first song
            gMyPlaylistPosition = 1
         Else
            'leave the pointer to the last song and exit
            gMyPlaylistPosition = gMyPlaylist.count
            Exit Sub
         End If
      End If
      'set flag
      fSongChanged = True
      'start playing
      DXPlayerStartPlay
   Case WinAmpPlayer
      L = SendMessage(WinAmpHwnd, WM_COMMAND, WINAMP_BUTTON5, ZERO)
   Case SoniquePlayer
      Shell (gsPlayerPath & " -SeekNext")
   End Select
End Sub

Sub PlayNow()
   'start playing now
   
   'depending on player
   Select Case gMusicPlayer
      Case InternalPlayer
         Dim MyState As Long
         If Not DXPlayer Is Nothing Then
            DXPlayer.GetState L, MyState
            If MyState = 1 Then PausePlayer: Exit Sub
         End If
         DXPlayerStartPlay
      Case WinAmpPlayer
         If fFade = False Then SetPlayerVolume PlayerVolPercent
         L = SendMessage(WinAmpHwnd, WM_WA_IPC, ZERO, IPC_STARTPLAY)
      Case SoniquePlayer
         Shell (gsPlayerPath & " -play")
   End Select
   
   ' enable player timer
   'With FMain
   '   .PlayerTimer.Enabled = True
  ' End With
End Sub

Sub DXPlayerStartPlay()
   'start playing the song from the playlist
   'catch error
   On Error GoTo Hell
   
   'initialize player
   Set DXPlayer = New FilgraphManager
   Set DXPlayerPosition = DXPlayer
   
   'get filename to play from playlist
   v = gMyPlaylist(gMyPlaylistPosition)
   s = v
   Dim Filename As String
   Filename = GetFileName(s)
   
   gsPlayingFileName = Filename
   
   Scroll_Song = String(20, " ") + Filename
   'load the song in the player
   DXPlayer.RenderFile s
   
   'set the volume if it was not previously set
    
   
        PlayerVolPercent = Base.Volume_Slider.Value
        SetPlayerVolume PlayerVolPercent
   
   
     
   'and play it
   DXPlayer.Run
   
   'set flag and enable timer
   DXPlayerPlaying = True
   'FMain.PlayerTimer.Enabled = True
   Exit Sub
Hell:
   'got an error.
   StopPlayer
   
   'notify user there was an error
   MsgBox "Internal player unable to play."
   'and close all open files (likely cause for the error is because a file is open)
   Close
End Sub

Sub StartPlayFromPosition(Position As Long)
   'internal player - start play from a specified position
   
   DXPlayerPosition.CurrentPosition = Position
   DXPlayerPlaying = True
   DXPlayer.Run
End Sub

Sub StartWinampAndWait()
   'start Winamp and wait for it to load
   
   'error handler
   On Error GoTo Hell
   
   'run winamp
   Shell gsPlayerPath
   
   'keep looping until the window is found
   Do Until WinAmpHwnd <> 0
      WinAmpHwnd = FindWindow("Winamp v1.x", vbNullString)
      DoEvents
   Loop
   'set the volume to 80%
   SetPlayerVolume 80
   Exit Sub
Hell:
   'most likely winamp is not located where the registry says it is.
   'display message
   MsgBox "Unable to load WinAmp"
End Sub

Function FindWinamp() As Boolean
   'find the winamp window
   
   'find it
   WinAmpHwnd = FindWindow("Winamp v1.x", vbNullString)
   
   'if not found then load it and wait for it to load
   If WinAmpHwnd = 0 Then
      StartWinampAndWait
   End If
   
   'return true
   FindWinamp = True
End Function

Function GetAmpState() As udtAmpState
   'get the state of winamp..
   B = SendMessage(WinAmpHwnd, WM_WA_IPC, ZERO, IPC_ISPLAYING)
   'and return the state
   GetAmpState = B
'   Select Case b
'   Case 0
'      GetAmpState = 2 'stop
'   Case 1
'      GetAmpState = 0 'play
'   Case 3
'      GetAmpState = 1 'paused
'   Case Else
'      GetAmpState = 3 'error
'End Select

End Function

Sub AddFileToListNow(Filename As String)
   'add a song to winamp's playlist
   

   Dim cds As COPYDATASTRUCT
   Dim Buf() As Byte
   'copy the filename into a byte array
  
   Buf = StrConv(Filename, vbFromUnicode)
   'append null to last string (VB will do this for us)
   ReDim Preserve Buf(Len(Filename))

   'prepare copydata
   cds.dwData = IPC_PLAYFILE
   cds.cbData = Len(Filename) + 1
   cds.lpData = VarPtr(Buf(0))
   
   'send the copy data
   L = SendMessagePtr(WinAmpHwnd, WM_COPYDATA, ZERO, cds)

End Sub

Function GetAmpCaption() As String
   'Get Winamp's caption
   
   Dim WinText As String
   
   'this is standard to all windows if you know the handle
   WinText = Space(256)
   L = GetWindowText(WinAmpHwnd, WinText, 255)
   'return the caption
   GetAmpCaption = Left$(WinText, L)
End Function
Sub SeekTo(Position As Long)
   Select Case gMusicPlayer
   Case InternalPlayer
      If DXPlayer Is Nothing Then Exit Sub
      DXPlayerPosition.CurrentPosition = Position
   Case WinAmpPlayer
      L = SendMessage(WinAmpHwnd, WM_WA_IPC, Position * 1000, IPC_JUMPTOTIME)
   End Select
End Sub

Function SetPlayerVolume(Percent As Long) As Boolean
   
   'set the volume of the player
   'FMain.picVolume.Left = Percent
   'depending on the player
   Select Case gMusicPlayer
      Case InternalPlayer
         'make sure player is active
         'If DXPlayer Is Nothing Then GoTo Here
         If DXPlayer Is Nothing Then Set DXPlayer = New FilgraphManager
         'calculate volume to set
         Set DXPlayerAudio = DXPlayer
         L = (Percent * 100) - 10000
         'and send it
         DXPlayerAudio.Volume = L
      Case WinAmpPlayer
         'calculate volume to set
         L = CByte(Percent * 255 / 100)
         'send it
         FindWinamp
         L = SendMessage(WinAmpHwnd, WM_WA_IPC, L, IPC_SETVOLUME)
      Case SoniquePlayer
      'Sonique Can't Do This!
   End Select
Here:
   
End Function

Sub SetMasterVolume()
   'set master wave volume (in this case to full volume)
   L = WaveOutSetVolume(ZERO, &HFFFFFFFF)
End Sub

Sub SetPlayerToWinAmp(RegKey As String)
   'sets the player to winamp
   
   'if not found in the registry, set player to internal player
   If RegKey = NOT_FOUND Then
      gMusicPlayer = InternalPlayer
      SetMasterVolume
      Exit Sub
   End If
   
   'strip out quotes if there.
   If Left$(RegKey, 1) = sQuote2 Then RegKey = Mid$(RegKey, 2, Len(RegKey) - 7)
   
   'set the player
   gMusicPlayer = WinAmpPlayer
   gsPlayerPath = RegKey
   
   'find last backslash
   i = InStrRev(RegKey, sBSlash)
   
   'set path to winamp directory
   If i > 0 Then WinAmpPlaylist = Left$(RegKey, i)
   
   'append name of playlist to the path
   WinAmpPlaylist = WinAmpPlaylist & "WinAmp.M3U"
      
   'find the winamp window
   FindWinamp
   
   'set default volume
   SetPlayerVolume 80
    'and set the volume slider
End Sub

Public Sub SafeWriteTag(Filename As String)
   'wrapper for the WriteTag function of cmp3 so it
   'doesn't try to write to a file open by the internal player.
   On Error GoTo Hell
   Dim SongPosition As Long
   If UCase(Right$(Filename, 3)) = "MID" Then Exit Sub 'we don't write tags to .MID files
   If gMusicPlayer = InternalPlayer Then
      'note even if song is stopped, if the player is set to this file,
      'it leaves it open.
      If gsPlayingFileName = Filename And Not DXPlayer Is Nothing Then
         SongPosition = DXPlayerPosition.CurrentPosition
         DXPlayer.Stop
         ClearDXPlayer
         'safe to write now
         'song.WriteTag
         'start player back up if it was playing
         If DXPlayerPlaying = True Then
            Set DXPlayer = New FilgraphManager
            Set DXPlayerPosition = DXPlayer
            Set DXPlayerAudio = DXPlayer
            DXPlayer.RenderFile Filename
            DXPlayerPosition.CurrentPosition = SongPosition
            SetPlayerVolume PlayerVolPercent
            DXPlayer.Run
         End If
      Else
         'song.WriteTag
      End If
   Else
      'song.WriteTag
   End If
   Exit Sub
Hell:
   MsgBox "SafeWriteTag: " & Err.Description & ".  The file that is causing the problem is: " & Filename
End Sub
