Attribute VB_Name = "mStart"
'Music Collector
'
'(c) 1999, 2000 by Joe Hart
'
'You do NOT have rights to redistribute this code, in whole or in part without
'my permission.  You also may not recompile the code and release
'it as another program without my permission.  If you would like to modify this code
'and distribute it in either as source code or as a compiled program please contact
'me at bghost@ti.cz before doing so.
'
'No warrantees either expressed or implied are granted with this software.
'Any damage arrising from use of this software is your own risk.
'
'mInitialize.bas

'I can tell you, if I were to rewrite the code today, I would do a lot of things differently
'but alas, this is how it was built.. it was a definate learning experience for me.
'You will see a slight mixute of coding styles in this project.  The main reason is that as
'became more familiar with VB, I adapted my style.

'begin with this module.... initialize variables and display splash
Option Explicit

Public LS() As String 'the strings used... defined by Language class

'global classes
'Public song As cMP3
Public Data As cData
'Public LangSelect As CLanguage
'Public INI As cINI
   
'Type Library not correct for these structures, as type library can't do strings in structures
Public Type WIN32_FIND_DATA
  dwFileAttributes As Long
  ftCreationTime As FILETIME
  ftLastAccessTime As FILETIME
  ftLastWriteTime As FILETIME
  nFileSizeHigh As Long
  nFileSizeLow As Long
  dwReserved0 As Long
  dwReserved1 As Long
  cFileName As String * 260
  cAlternate As String * 14
End Type

Public Type SHFILEOPSTRUCT
    hwnd As Long
    wFunc As Long
    pFrom As String
    pTo As String
    fFlags As Integer
    fAnyOperationsAborted As Long
    hNameMappings As Long
    lpszProgressTitle As Long
End Type

'Enumerations

'Winamp playing state
Public Enum udtAmpState
  asStop = 0
  asplay
  asError
  asPause
End Enum

Public Enum udtMusicPlayer
   InternalPlayer = 0
   WinAmpPlayer
   SoniquePlayer
End Enum

'constants.for commonly used strings
Public Const WINAMP_REG_KEY = "WinAmp.File\shell\play\command"
Public Const SONIQUE_REG_KEY = "Sonique.File\shell\play\command"
Public Const BASE_SQL = "SELECT CHOSEN,TITLE,ARTIST,ALBUM,GENRE,LENGTH,YEAR,QUALITY,SITUATION,MOOD,TYPE,COMMENT,FILENAME,BYTES,VOLUME,OnCD,HASLYRICS FROM MUSIC "
Public Const ORDERBY = " Order By "
Public Const NOT_FOUND = "Not Found"
Public Const WHERE_CHOSEN_TRUE = "Where Chosen = True"
Public Const GRIDCOLS = 16
Public Const SETTINGS = "Settings"

'constants for the buttons
Public Const PREV_BUTTON = 0
Public Const REW_BUTTON = 1
Public Const PLAY_BUTTON = 2
Public Const FF_BUTTON = 3
Public Const PAUSE_BUTTON = 4
Public Const STOP_BUTTON = 5
Public Const NEXT_BUTTON = 6
Public Const ENQUEUE_BUTTON = 7
Public Const COLLAPSE_BUTTON = 8
Public Const SEARCH_BUTTON = 9
Public Const MINIMIZE_BUTTON = 10
Public Const MAXIMIZE_BUTTON = 11
Public Const EXIT_BUTTON = 12
Public Const BUTTONWIDTH = 30
Public Const BUTTONHEIGHT = 20
Public Const BUTTONSTARTX = 20
Public Const BUTTONY = 70

Public Const ZERO = 0&

'internal player
Public DXPlayer As IMediaControl
Public DXPlayerPosition As IMediaPosition
Public DXPlayerAudio As IBasicAudio
Public DXPlayerPlaying As Boolean

'standard def to keep from having to redim them, values are only temporary
Public s As String
Public i As Integer 'usually used for loops
Public j As Integer 'usually used for loops
Public L As Long 'uppercase to avoid confusion with the 1 (l and 1 look very similar in some fonts)
Public B As Byte
Public v As Variant
Public f As Boolean 'f for flag

'Global Variables (All these variables are used by more than one module or form)
'ones marked as bad should be moved to module level, or replaced in local procuderes.
Public CONNECT_STRING As String 'it is constant, but can't be a constant because we don't know path for the database is
Public gsSQL As String 'the SQL Query.  Changes frequently in several different places.
Public HelpFileName As String 'the name of the helpfile.  We cannot use App.HelpFile because it doesn't work correctly with HTML help.
Public gsCurFileName As String 'current filename in the grid
Public gsGenres As String 'the genres
Public gfSelecting As Boolean 'selecting songs?
Public gfNoRecords As Boolean 'no records in database?
Public gsPlayerPath As String 'path to external player
Public gMusicPlayer As udtMusicPlayer 'which MusicPlayer
Public gSelectedBorder As Long 'highlight border color
Public gNormalBackColor As Long 'normal background color
Public gNormalForeColor As Long 'normal foreground color
Public gSelectedBackColor As Long 'highlighted background color
Public gSelectedForeColor As Long 'highlighted foreground color
Public gLyricsBackColor As Long 'if song las lyrics background color
Public gLyricsForeColor As Long 'if song has lyrics foreground color
Public gFixedBackColor As Long 'BackColor of fixed cells
Public gFixedForeColor As Long 'ForeColor of fixed cells
Public gasMusicSearchDir() As String 'the search directories
Public gsDefaultSortOrder As String 'the default sort order
Public gTagMethod As Integer 'which tag method is used
Public gMyPlaylist As Collection 'the internal playlist
Public gMyPlaylistPosition As Integer 'the position in the internal playlist
Public gsPlayingFileName As String 'the name of the playing file
Public fCDUsed As Boolean 'is the cd used
Public fPreviousWarning As Boolean 'was the user warned already?
Public fSongChanged As Boolean 'did the song change
Public fPlaylistChanged As Boolean 'did the playlist change
Public fSearchForMP3 As Boolean 'do we search for mp3 files
Public fSearchForMID As Boolean 'do we search for midi files
Public fSearchForWMA As Boolean 'do we search for WMA files
Public gfChangedLangs As Boolean ''did the language change?
Public LastUpdate As Double 'bad
Public IsCDROM As Boolean 'bad
Public HasLyrics3Tag As Boolean 'bad
Public UnknownLyrics3Fields As String 'bad
Public VolLabel As String 'bad
Public ExistsInDB As Boolean 'bad
Public sFileExtension As String 'bad
Public Size As Long 'bad
Public DoDelay As Boolean 'do we delay on executes to the database?
Public FTemp As Form 'Temporary form (used to show modal forms)
Public FMain As Form 'mainForm
Public FPrefs As Form 'preferences form (this is a modal form, but it has a link to another form)
Public FPlaylist As Form 'playlist
Public fShowingLyrics As Boolean 'do we show the lyrics
Public WinAmpHwnd As Long 'the window handle of WinAmp
Public WinAmpPlaylist As String 'the filename (and location) of the winamp playlist
Public sCopyDir As String 'the directory to copy files to
Public sMoveDir As String 'the directory to move files to
Public gfConfirmCopyMove As Boolean 'confirm copies and moves?
Public gfConfirmDelete As Boolean 'confirm deletes?
Public PlayerCurrentPosition As Long 'the current position of the player (in seconds)
Public SongDur As Long 'the length of the current song in secs
Public PlayerVolPercent As Long 'the percentage of the volume for the player
Public PlayerPosPercent As Long 'the percentage of the current play position
Public fFade As Boolean 'shoud we fade?
Public fPlayRepeat As Boolean 'Should the player repeat?
Public AutoFadePercent As Long 'percentage of song we start fading at
Public GridFont As StdFont 'allow us to change fonts quickly.

'main grid columns, more than one form has access to the grid....
Public colTitle As Long
Public colArtist As Long
Public colAlbum As Long
Public colGenre As Long
Public colLength As Long
Public colYear As Long
Public colQuality As Long
Public colSituation As Long
Public colMood As Long
Public colType As Long
Public colComment As Long
Public colFileName As Long
Public colBytes As Long
Public colVolume As Long
Public colChosen As Long
Public colOnCD As Long
Public colHasLyrics As Long
Public colTitleWidth As Long
Public colArtistWidth As Long
Public colLengthWidth As Long
Public colFileNameWidth As Long
Public colAlbumWidth As Long
Public colGenreWidth As Long
Public colYearWidth As Long
Public colQualityWidth As Long
Public colSituationWidth As Long
Public colMoodWidth As Long
Public colTypeWidth As Long
Public colCommentWidth As Long
Public colBytesWidth As Long
Public colVolumeWidth As Long
Public colChosenWidth As Long
Public colOnCDWidth As Long
Public colHasLyricsWidth As Long

'********************************
'   Function Declarations       *
'********************************

'api calls not in type library or not correct in type library
Declare Function FindFirstFile Lib "kernel32" Alias "FindFirstFileA" (ByVal lpFileString As String, lpFindFileData As WIN32_FIND_DATA) As Long
Declare Function FindNextFile Lib "kernel32" Alias "FindNextFileA" (ByVal hFindFile As Long, lpFindFileData As WIN32_FIND_DATA) As Long
Declare Function SHFileOperation Lib "Shell32.dll" Alias "SHFileOperationA" (lpFileOp As SHFILEOPSTRUCT) As Long
Declare Function HtmlHelp Lib "HHCtrl.ocx" Alias "HtmlHelpA" (ByVal hwndCaller As Long, ByVal pszFile As String, ByVal uCommand As Long, dwData As Any) As Long
Declare Function WaveOutSetVolume Lib "WINMM.DLL" Alias "waveOutSetVolume" (ByVal uDeviceID As Long, ByVal dwVolume As Long) As Long
Declare Function RegOpenKey Lib "advapi32.dll" Alias "RegOpenKeyA" (ByVal hKey As Long, ByVal lpSubKey As String, phkResult As Long) As Long
Declare Function RegQueryValueEx Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, ByVal lpData As String, lpcbData As Long) As Long
Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hKey As Long) As Long
Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Declare Function SendMessagePtr Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
